#load libraries
#please ensure package pcalg is installed prior to use this source code
library(pcalg)
library(classGraph)
source("pcalg_know.R")


#read expression profile data and initialization
file="your expression profile after differential expression analysis"
header<-readHeader(file)
num_miRNA<-35
miRNA<-header[1:num_miRNA]
mRNA<-header[-(1:num_miRNA)]
dt<-Read(file)
stdData<-Standardise(dt)


#generate prior knowledge matrix
edgeTargetScan<-queryTargetFile(miRNA,mRNA,"yourknowledgematrix"); edgeTargetScan<-edgeTargetScan+t(edgeTargetScan);edgeTargetScan<-edgeTargetScan!=0;

#Estimate and output causal effects of the miRNAs on mRNAs

resultTargetScan<-CIDER(miRNA,mRNA,stdData,0.01,num_miRNA,fixedEdge=edgeTargetScan,skel.method='stable')
resultTransMir<-CIDER(miRNA,mRNA,stdData,0.01,num_miRNA,fixedEdge=edgeTransMir,skel.method='stable')
